# Cortex [![NPM version](https://badge.fury.io/js/cortex.png)](http://badge.fury.io/js/cortex) [![Build Status](https://travis-ci.org/cortexjs/cortex.png?branch=master)](https://travis-ci.org/cortexjs/cortex)

#### /ˈkɔːrteks/

[English](./README.md)

**Cortex** 是一个专为 Web 开发设计的包管理器（类似于 Java 的 maven 或者 node.js 的 npm）。

而与之配套的，Cortex 包括一整套端到端的前端集成解决方案:

- 模块管理及精心设计的版本控制方案；
- 与之配套的后端解决方案，目前支持语言有：Java；
- 涵盖你整个研发周期的开发环境；
- 成熟的[持续集成方案](http://en.wikipedia.org/wiki/Continuous_integration)，并能够平滑支持多套灰度测试环境;
- 模块仓库服务;
- CDN 解决方案.

使用 Cortex，你能够完全像 node.js 一样开发前端应用，而不用去关心任何诸如 AMD 之类的规范。


## 为什么取名为 Cortex ？

网页中的模块和对象会互相作用，协同，传递信息，就好比人体中的神经元（即神经细胞，neuron /'njʊərɒn/）一样：

<center>
<img alt="" src="https://raw.githubusercontent.com/cortexjs/cortex/master/screenshots/neurons.jpg" />
</center>

而 Cortex 的意思是 **大脑皮层**，它属于神经系统中最晚出现最为发达的系统，用于调节人体各方面的技能。因此，我们把 web 的模块管理器，取名为 cortex，与之对应的，[neuron](https://github.com/kaelzhang/neuron) 是一个轻量而强大客户端模块加载器。


## 安装

首先，你至少需要安装 [node](http://nodejs.org) 0.8.0，然后在你的命令行终端中运行如下命令： 

```sh
npm install -g cortex
```

根据实际情况，可能需要使用 sudo。

## 快速开始

可以阅读我们的 [新手指引](https://github.com/cortexjs/wiki/blob/master/zh-CN/cortex/getting-started.md) 文档，它可以帮助你快速进行开发。

如果想详细了解 cortex，可以访问我们的 wiki：[cortexjs/wiki](https://github.com/cortexjs/wiki)，其中会包含你所需要了解的方方面面。

## 发音技巧

Cortex 发长音 /ɔː/ 哦，美式的发音会比较倾向于 /ˈkɔː**r**teks/，大北京的大哥们发音一定会很准，没错，“儿” 化音的赶脚。

如果发音 /'kɑteks/，这样是不对的！这样就变成高洁丝（kotex）了 \_(:3」∠)_

你们一定懂我的意思的！

